package logging

import (
	"fmt"
	"os"
	"path/filepath"

	"git.sr.ht/~cco/go-scopes/config"
	"git.sr.ht/~cco/go-scopes/lib"
	"github.com/rs/zerolog"
	"github.com/rs/zerolog/log"
)

type Logger = zerolog.Logger

var globalLogger *Logger = &log.Logger

type Cfg struct {
	*config.BaseCfg
	Logfile string
	Level   zerolog.Level
}

func Setup(ctx lib.Context, cfg *Cfg, home string) {
	if cfg == nil {
		return // use unchanged predefined logger
	}
	home, _ = filepath.Abs(home)
	fn := cfg.Logfile
	// TODO: use: logger := New(cfg, home)
	if fn == "" {
		fn = filepath.Join(home, "log", "scopes.log")
	} else if !filepath.IsAbs(fn) {
		fn = filepath.Join(home, fn)
	}
	fmt.Println("logfile:", fn)
	if f, err := os.OpenFile(fn, os.O_WRONLY|os.O_APPEND|os.O_CREATE, 0664); err == nil {
		logger := zerolog.New(f).With().Timestamp().Logger()
		*globalLogger = logger
	} else {
		panic(err)
	}
}

func New(cfg *Cfg, home string) *Logger {
	return nil
}

func GetLogger(ctx lib.Context) *Logger {
	if ctx == nil {
		return globalLogger
	}
	return nil
}
